Box2D: b2World Class Reference

| Box2D 2.4.1 A 2D physics engine for games

Loading...
Searching...
No Matches
Public Member Functions | Friends | List of all members
b2World Class Reference

`#include <b2_world.h>`

## Public Member Functions
| b2World (const b2Vec2 &gravity)
| ~b2World ()
| Destruct the world. All physics entities are destroyed and all heap memory is released.
void | SetDestructionListener (b2DestructionListener *listener)
void | SetContactFilter (b2ContactFilter *filter)
void | SetContactListener (b2ContactListener *listener)
void | SetDebugDraw (b2Draw *debugDraw)
b2Body * | CreateBody (const b2BodyDef *def)
void | DestroyBody (b2Body *body)
b2Joint * | CreateJoint (const b2JointDef *def)
void | DestroyJoint (b2Joint *joint)
void | Step (float timeStep, int32 velocityIterations, int32 positionIterations)
void | ClearForces ()
void | DebugDraw ()
| Call this to draw shapes and other debug draw data. This is intentionally non-const.
void | QueryAABB (b2QueryCallback *callback, const b2AABB &aabb) const
void | RayCast (b2RayCastCallback *callback, const b2Vec2 &point1, const b2Vec2 &point2) const
b2Body * | GetBodyList ()
const b2Body * | GetBodyList () const
b2Joint * | GetJointList ()
const b2Joint * | GetJointList () const
b2Contact * | GetContactList ()
const b2Contact * | GetContactList () const
void | SetAllowSleeping (bool flag)
| Enable/disable sleep.
bool | GetAllowSleeping () const
void | SetWarmStarting (bool flag)
| Enable/disable warm starting. For testing.
bool | GetWarmStarting () const
void | SetContinuousPhysics (bool flag)
| Enable/disable continuous physics. For testing.
bool | GetContinuousPhysics () const
void | SetSubStepping (bool flag)
| Enable/disable single stepped continuous physics. For testing.
bool | GetSubStepping () const
int32 | GetProxyCount () const
| Get the number of broad-phase proxies.
int32 | GetBodyCount () const
| Get the number of bodies.
int32 | GetJointCount () const
| Get the number of joints.
int32 | GetContactCount () const
| Get the number of contacts (each may have 0 or more contact points).
int32 | GetTreeHeight () const
| Get the height of the dynamic tree.
int32 | GetTreeBalance () const
| Get the balance of the dynamic tree.
float | GetTreeQuality () const
void | SetGravity (const b2Vec2 &gravity)
| Change the global gravity vector.
b2Vec2 | GetGravity () const
| Get the global gravity vector.
bool | IsLocked () const
| Is the world locked (in the middle of a time step).
void | SetAutoClearForces (bool flag)
| Set flag to control automatic clearing of forces after each time step.
bool | GetAutoClearForces () const
| Get the flag that controls automatic clearing of forces after each time step.
void | ShiftOrigin (const b2Vec2 &newOrigin)
const b2ContactManager & | GetContactManager () const
| Get the contact manager for testing.
const b2Profile & | GetProfile () const
| Get the current profile.
void | Dump ()

## Friends
class | b2Body
class | b2Fixture
class | b2ContactManager
class | b2Controller

## Detailed Description

The world class manages all physics entities, dynamic simulation, and asynchronous queries. The world also contains efficient memory management facilities.

## Constructor & Destructor Documentation

## ◆ b2World()

b2World::b2World | ( | const b2Vec2 & | gravity | ) |

Construct a world object.

Parameters

  gravity | the world gravity vector.

## Member Function Documentation

## ◆ ClearForces()

void b2World::ClearForces | ( |  | ) |

Manually clear the force buffer on all bodies. By default, forces are cleared automatically after each call to Step. The default behavior is modified by calling SetAutoClearForces. The purpose of this function is to support sub-stepping. Sub-stepping is often used to maintain a fixed sized time step under a variable frame-rate. When you perform sub-stepping you will disable auto clearing of forces and instead call ClearForces after all sub-steps are complete in one pass of your game loop.

See also
  SetAutoClearForces

## ◆ CreateBody()

b2Body * b2World::CreateBody | ( | const b2BodyDef * | def | ) |

Create a rigid body given a definition. No reference to the definition is retained.

Warning
  This function is locked during callbacks.

## ◆ CreateJoint()

b2Joint * b2World::CreateJoint | ( | const b2JointDef * | def | ) |

Create a joint to constrain bodies together. No reference to the definition is retained. This may cause the connected bodies to cease colliding.

Warning
  This function is locked during callbacks.

## ◆ DestroyBody()

void b2World::DestroyBody | ( | b2Body * | body | ) |

Destroy a rigid body given a definition. No reference to the definition is retained. This function is locked during callbacks.

Warning
  This automatically deletes all associated shapes and joints.
  This function is locked during callbacks.

## ◆ DestroyJoint()

void b2World::DestroyJoint | ( | b2Joint * | joint | ) |

Destroy a joint. This may cause the connected bodies to begin colliding.

Warning
  This function is locked during callbacks.

## ◆ Dump()

void b2World::Dump | ( |  | ) |

Dump the world into the log file.

Warning
  this should be called outside of a time step.

## ◆ GetBodyList()

b2Body * b2World::GetBodyList | ( |  | ) |
| inline

Get the world body list. With the returned body, use b2Body::GetNext to get the next body in the world list. A nullptr body indicates the end of the list.

Returns
  the head of the world body list.

## ◆ GetContactList()

b2Contact * b2World::GetContactList | ( |  | ) |
| inline

Get the world contact list. With the returned contact, use b2Contact::GetNext to get the next contact in the world list. A nullptr contact indicates the end of the list.

Returns
  the head of the world contact list.

Warning
  contacts are created and destroyed in the middle of a time step. Use b2ContactListener to avoid missing contacts.

## ◆ GetJointList()

b2Joint * b2World::GetJointList | ( |  | ) |
| inline

Get the world joint list. With the returned joint, use b2Joint::GetNext to get the next joint in the world list. A nullptr joint indicates the end of the list.

Returns
  the head of the world joint list.

## ◆ GetTreeQuality()

float b2World::GetTreeQuality | ( |  | ) | const

Get the quality metric of the dynamic tree. The smaller the better. The minimum is 1.

## ◆ QueryAABB()

void b2World::QueryAABB | ( | b2QueryCallback * | callback,
|  | const b2AABB & | aabb
| ) |  | const

Query the world for all fixtures that potentially overlap the provided AABB.

Parameters

  callback | a user implemented callback class.
  aabb | the query box.

## ◆ RayCast()

void b2World::RayCast | ( | b2RayCastCallback * | callback,
|  | const b2Vec2 & | point1,
|  | const b2Vec2 & | point2
| ) |  | const

Ray-cast the world for all fixtures in the path of the ray. Your callback controls whether you get the closest point, any point, or n-points. The ray-cast ignores shapes that contain the starting point.

Parameters

  callback | a user implemented callback class.
  point1 | the ray starting point
  point2 | the ray ending point

## ◆ SetContactFilter()

void b2World::SetContactFilter | ( | b2ContactFilter * | filter | ) |

Register a contact filter to provide specific control over collision. Otherwise the default filter is used (b2_defaultFilter). The listener is owned by you and must remain in scope.

## ◆ SetContactListener()

void b2World::SetContactListener | ( | b2ContactListener * | listener | ) |

Register a contact event listener. The listener is owned by you and must remain in scope.

## ◆ SetDebugDraw()

void b2World::SetDebugDraw | ( | b2Draw * | debugDraw | ) |

Register a routine for debug drawing. The debug draw functions are called inside with b2World::DebugDraw method. The debug draw object is owned by you and must remain in scope.

## ◆ SetDestructionListener()

void b2World::SetDestructionListener | ( | b2DestructionListener * | listener | ) |

Register a destruction listener. The listener is owned by you and must remain in scope.

## ◆ ShiftOrigin()

void b2World::ShiftOrigin | ( | const b2Vec2 & | newOrigin | ) |

Shift the world origin. Useful for large worlds. The body shift formula is: position -= newOrigin

Parameters

  newOrigin | the new origin with respect to the old origin

## ◆ Step()

void b2World::Step | ( | float | timeStep,
|  | int32 | velocityIterations,
|  | int32 | positionIterations
| ) |  |

Take a time step. This performs collision detection, integration, and constraint solution.

Parameters

  timeStep | the amount of time to simulate, this should not vary.
  velocityIterations | for the velocity constraint solver.
  positionIterations | for the position constraint solver.

The documentation for this class was generated from the following file:

- /build/box2d/src/box2d-2.4.2/include/box2d/b2_world.h